<template>
  <div class="timeline-wrapper">
    <div class="chart-container"></div>
  </div>
</template>

<script>
import * as d3 from 'd3'
import Highcharts from 'highcharts'
import UtilsService from '@/services/UtilsService'
export default {
  props: {
    series: {
      type: Array,
      required: true,
    },
    title: {
      type: String,
      default: '',
    },
    suffix: {
      type: String,
      default: '',
    },
    colors: {
      type: Array,
      default() {
        return [
          // Default Highcharts colors
          '#7cb5ec',
          '#434348',
          '#90ed7d',
          '#f7a35c',
          '#8085e9',
          '#f15c80',
          '#e4d354',
          '#2b908f',
          '#f45b5b',
          '#91e8e1',
        ]
      },
    },
    labels: {
      type: Boolean,
      default: false,
    },
    height: {
      type: String,
      default: undefined,
    },
    width: {
      type: String,
      default: undefined,
    },
  },
  data() {
    return {}
  },
  computed: {},
  watch: {
    series: {
      handler: 'drawChart',
    },
    labels: {
      handler: 'toggleLabels',
    },
  },
  methods: {
    toggleLabels() {
      if (this.labels) {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', null)
      } else {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', 'none')
      }
    },
    drawChart() {
      const self = this
      Highcharts.setOptions({
        colors: this.colors,
      })
      const $container = d3.select(this.$el).select('.chart-container').node()
      let min = 0
      if (this.series[0] && this.series[0].data) {
        min = d3.min(this.series, (o) => d3.min(o.data.map((o2) => o2[1])))
      }
      Highcharts.chart({
        chart: {
          renderTo: $container,
          type: 'spline',
          zoomType: 'x',
          height: this.height,
          width: this.width,
        },
        title: {
          text: self.title,
        },
        subtitle: {
          text: this.$t('analytics.monthly-counts'),
        },
        xAxis: {
          type: 'datetime',
          title: {
            text: this.$t('analytics.date'),
          },
        },
        yAxis: {
          title: {
            text: this.$t('analytics.number-of-requests'),
          },
          min: d3.min([0, min]),
          labels: {
            formatter() {
              return `${UtilsService.formatNumber(this.value)}${self.suffix}`
            },
          },
        },
        tooltip: {
          headerFormat: '<b>{series.name}</b><br>',
          pointFormatter() {
            return `${d3.timeFormat("%b '%y")(
              new Date(this.x)
            )}: ${UtilsService.formatNumber(this.y)}${self.suffix}`
          },
        },
        plotOptions: {
          spline: {
            marker: {
              enabled: true,
            },
          },
          series: {
            dataLabels: {
              enabled: true,
              formatter() {
                return `${UtilsService.formatNumber(this.point.y)}${
                  self.suffix
                }`
              },
            },
          },
        },
        // Define the data points. All series have a dummy year
        // of 1970/71 in order to be compared on the same x axis. Note
        // that in JavaScript, months start at 0 for January, 1 for February etc.
        series: this.series,
      })
      this.toggleLabels()
    },
  },
  render(createElement) {
    return createElement('div')
  },
}
</script>

<style></style>
